function encode64(b) {
    for (var d = "", e, a, f, l, n, m, p = 0; p < b.length;) e = b.charCodeAt(p++), a = b.charCodeAt(p++), f = b.charCodeAt(p++), l = e >> 2, e = (e & 3) << 4 | a >> 4, n = (a & 15) << 2 | f >> 6, m = f & 63, isNaN(a) ? n = m = 64 : isNaN(f) && (m = 64), d = d + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(l) + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(e) + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(n) + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(m);
    return d
}

function SHA1Bytes(b) {
    function d(a, b) {
        return a << b | a >>> 32 - b
    }

    function e(a) {
        var b = "",
            c;
        for (c = 7; 0 <= c; c--) {
            var d = a >>> 4 * c & 15;
            b += d.toString(16)
        }
        return b
    }
    var a, f = Array(80),
        l = 1732584193,
        n = 4023233417,
        m = 2562383102,
        p = 271733878,
        u = 3285377520;
    var c = b.length;
    var t = [];
    for (a = 0; a < c - 3; a += 4) {
        var g = b[a] << 24 | b[a + 1] << 16 | b[a + 2] << 8 | b[a + 3];
        t.push(g)
    }
    switch (c % 4) {
        case 0:
            a = 2147483648;
            break;
        case 1:
            a = b[c - 1] << 24 | 8388608;
            break;
        case 2:
            a = b[c - 2] << 24 | b[c - 1] << 16 | 32768;
            break;
        case 3:
            a = b[c - 3] << 24 | b[c - 2] << 16 | b[c - 1] << 8 | 128
    }
    for (t.push(a); 14 != t.length % 16;) t.push(0);
    t.push(c >>> 29);
    t.push(c << 3 & 4294967295);
    for (b = 0; b < t.length; b += 16) {
        for (a = 0; 16 > a; a++) f[a] = t[b + a];
        for (a = 16; 79 >= a; a++) f[a] = d(f[a - 3] ^ f[a - 8] ^ f[a - 14] ^ f[a - 16], 1);
        g = l;
        c = n;
        var h = m;
        var k = p;
        var q = u;
        for (a = 0; 19 >= a; a++) {
            var r = d(g, 5) + (c & h | ~c & k) + q + f[a] + 1518500249 & 4294967295;
            q = k;
            k = h;
            h = d(c, 30);
            c = g;
            g = r
        }
        for (a = 20; 39 >= a; a++) r = d(g, 5) + (c ^ h ^ k) + q + f[a] + 1859775393 & 4294967295, q = k, k = h, h = d(c, 30), c = g, g = r;
        for (a = 40; 59 >= a; a++) r = d(g, 5) + (c & h | c & k | h & k) + q + f[a] + 2400959708 & 4294967295, q = k, k = h, h = d(c, 30), c = g, g = r;
        for (a = 60; 79 >= a; a++) r = d(g, 5) + (c ^ h ^ k) + q + f[a] + 3395469782 & 4294967295, q = k, k = h, h = d(c, 30), c = g, g = r;
        l = l + g & 4294967295;
        n = n + c & 4294967295;
        m = m + h & 4294967295;
        p = p + k & 4294967295;
        u = u + q & 4294967295
    }
    r = e(l) + e(n) + e(m) + e(p) + e(u);
    return r.toUpperCase()
}

function SHA1(b) {
    function d(a, b) {
        return a << b | a >>> 32 - b
    }

    function e(a) {
        var b = "",
            c;
        for (c = 7; 0 <= c; c--) {
            var d = a >>> 4 * c & 15;
            b += d.toString(16)
        }
        return b
    }
    var a, f = Array(80),
        l = 1732584193,
        n = 4023233417,
        m = 2562383102,
        p = 271733878,
        u = 3285377520;
    b = function(a) {
        a = a.replace(/\r\n/g, "\n");
        for (var b = "", c = 0; c < a.length; c++) {
            var d = a.charCodeAt(c);
            128 > d ? b += String.fromCharCode(d) : (127 < d && 2048 > d ? b += String.fromCharCode(d >> 6 | 192) : (b += String.fromCharCode(d >> 12 | 224), b += String.fromCharCode(d >> 6 & 63 | 128)), b += String.fromCharCode(d & 63 | 128))
        }
        return b
    }(b);
    var c = b.length;
    var t = [];
    for (a = 0; a < c - 3; a += 4) {
        var g = b.charCodeAt(a) << 24 | b.charCodeAt(a + 1) << 16 | b.charCodeAt(a + 2) << 8 | b.charCodeAt(a + 3);
        t.push(g)
    }
    switch (c % 4) {
        case 0:
            a = 2147483648;
            break;
        case 1:
            a = b.charCodeAt(c - 1) << 24 | 8388608;
            break;
        case 2:
            a = b.charCodeAt(c - 2) << 24 | b.charCodeAt(c - 1) << 16 | 32768;
            break;
        case 3:
            a = b.charCodeAt(c - 3) << 24 | b.charCodeAt(c - 2) << 16 | b.charCodeAt(c - 1) << 8 | 128
    }
    for (t.push(a); 14 != t.length % 16;) t.push(0);
    t.push(c >>> 29);
    t.push(c << 3 & 4294967295);
    for (b = 0; b < t.length; b += 16) {
        for (a = 0; 16 > a; a++) f[a] = t[b + a];
        for (a = 16; 79 >= a; a++) f[a] = d(f[a - 3] ^ f[a - 8] ^ f[a - 14] ^ f[a - 16], 1);
        g = l;
        c = n;
        var h = m;
        var k = p;
        var q = u;
        for (a = 0; 19 >= a; a++) {
            var r = d(g, 5) + (c & h | ~c & k) + q + f[a] + 1518500249 & 4294967295;
            q = k;
            k = h;
            h = d(c, 30);
            c = g;
            g = r
        }
        for (a = 20; 39 >= a; a++) r = d(g, 5) + (c ^ h ^ k) + q + f[a] + 1859775393 & 4294967295, q = k, k = h, h = d(c, 30), c = g, g = r;
        for (a = 40; 59 >= a; a++) r = d(g, 5) + (c & h | c & k | h & k) + q + f[a] + 2400959708 & 4294967295, q = k, k = h, h = d(c, 30), c = g, g = r;
        for (a = 60; 79 >= a; a++) r = d(g, 5) + (c ^ h ^ k) + q + f[a] + 3395469782 & 4294967295, q = k, k = h, h = d(c, 30), c = g, g = r;
        l = l + g & 4294967295;
        n = n + c & 4294967295;
        m = m + h & 4294967295;
        p = p + k & 4294967295;
        u = u + q & 4294967295
    }
    r = e(l) + e(n) + e(m) + e(p) + e(u);
    return r.toUpperCase()
}

function stringToArray(b) {
    for (var d = [], e = 0; e < b.length; e += 1) d.push(b.charCodeAt(e));
    return d
}

function decode64Bytes(b) {
    var d = [],
        e = 0;
    for (b = b.replace(/[^A-Za-z0-9\+\/\=]/g, ""); e < b.length;) {
        var a = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(b.charAt(e++));
        var f = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(b.charAt(e++));
        var l = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(b.charAt(e++));
        var n = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(b.charAt(e++));
        a = a << 2 | f >> 4;
        f = (f & 15) << 4 | l >> 2;
        var m = (l & 3) << 6 | n;
        d.push(a);
        64 != l && d.push(f);
        64 != n && d.push(m)
    }
    return d
}

function parseHexaBytes(b) {
    for (var d = [], e = 0; e < b.length; e += 2) {
        var a = parseInt(b.substr(e, 2), 16);
        d.push(a)
    }
    return d
}

function encode64Bytes(b) {
    for (var d = "", e, a, f, l, n, m, p = 0; p < b.length;) e = b[p++], a = b[p++], f = b[p++], l = e >> 2, e = (e & 3) << 4 | a >> 4, n = (a & 15) << 2 | f >> 6, m = f & 63, isNaN(a) ? n = m = 64 : isNaN(f) && (m = 64), d = d + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(l) + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(e) + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(n) + "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".charAt(m);
    return d
}

function saltPwd(b, d, e) {
    b = parseHexaBytes(SHA1(b));
    e = decode64Bytes(e);
    d = stringToArray(d);
    d = SHA1Bytes(e.concat(d.concat(b)));
    return encode64Bytes(parseHexaBytes(d))
}

function randomString() {
    for (var b = "", d = Math.floor(1 * Math.random()) + 12, e = 0; e < d; e++) b += "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789".charAt(Math.floor(62 * Math.random()));
    return b
}

function createToken(b, d, e, a) {
    var f = (new Date).toISOString(),
        l = randomString(),
        l = encode64(l);
    e = saltPwd(e, f, l);
    return encode64(JSON.stringify({
        userId: d,
        organization: b,
        officeId: a,
        nonce: l,
        timestamp: f,
        password: e
    }))
};